( function ( $ ) {
    $( document ).ready( function () {

        let select_width = '487px';

        /**
         *
         *
         * ------------ ADMIN Scripts -----------
         *
         *
         */

        /* DESKTOP POSITION */
        $( '.boost-position' ).on( 'click', '.position-place:not(.disabled)', function () {
            let obj = this;
            if ( !$( obj ).hasClass( 'active' ) ) {
                $( obj ).parent().children( '.position-place' ).removeClass( 'active' );
                let new_position = $( obj ).attr( 'data-position' );
                $( obj ).parent().find( 'input.boost-position' ).val( new_position );
                $( obj ).addClass( 'active' );
            }
        } );

        /* SPINNER */

        $( '.spinner-control' ).on( 'click', function () {
            if ( $( this ).hasClass( 'spinner-down' ) ) {
                $( this ).parent().parent().find( 'input[type="number"]' )[ 0 ].stepDown();
            } else {
                $( this ).parent().parent().find( 'input[type="number"]' )[ 0 ].stepUp();
            }
        } );

        $( '.boost-page-tab-list' ).on( 'change', 'input[type="radio"]', function () {
            let obj = this;
            if ( $( obj ).prop( 'checked' ) ) {
                let tab = $( obj ).val();

                $.when( $( '.boost-tabs-container>*.boost-tab' ).not( '.boost-tab-' + tab ).hide( 'fast', function () {
                        $( '.boost-tabs-container>.boost-tab-' + tab ).show( 'fast', function () {
                        } )
                    } )
                ).then( function () {
                } );
            }
        } );

        $( '.boost-dropdown>.boost-dropdown-toggle' ).on( 'click', function () {
            $( this ).closest( '.boost-dropdown' ).children( '.boost-dropdown-content' ).toggle( "fast", function () {
                $( this ).closest( '.boost-dropdown' ).toggleClass( 'boost-dropdown-active' );
            } );
        } );

        $( document ).on( 'mouseup', function ( e ) {
            let dropdown_menu = $( ".boost-dropdown.boost-dropdown-active.boost-dropdown-menu" );
            if ( dropdown_menu.has( e.target ).length === 0 ) {
                dropdown_menu.children( '.boost-dropdown-toggle' ).trigger( 'click' );
            }
        } );

        $( '.boost-make-boost-subtype select' ).on( 'change', function () {
            let selectedSubtype = $( this ).val();
            let containersBoxId = $( this ).attr( 'data-containers-box-id' );
            let containerId = 'boost-make-boost-subtype-container-' + selectedSubtype;

            $( this ).closest( '.boost-make-boost-field' ).find( '.boost-make-boost-subtype-description.boost-active' ).removeClass( 'boost-active' );
            $( this ).closest( '.boost-make-boost-step-container' ).find( '.boost-make-boost-fake-block' ).hide();
            show_container( containersBoxId, containerId );
            $( this ).closest( '.boost-make-boost-field' ).find( '.boost-make-boost-subtype-description.boost-make-boost-subtype-' + selectedSubtype ).addClass( 'boost-active' );

            if ( selectedSubtype != 'stock_messages' ) {
                $( this ).closest( '.boost-make-boost-step-container' ).find( '.boost-make-boost-fake-block' ).show();
            }
        } );

        function show_container( containersBoxId, containerId ) {
            $.when( $( '#' + containersBoxId + '>*.boost-active' ).hide( 'fast', function () {
                $( this ).removeClass( 'boost-active' );
            } ) ).then( function () {
                $( '#' + containersBoxId + ' #' + containerId ).show( 'fast', function () {
                    $( this ).addClass( 'boost-active' );
                } );
            } );

        }

        String.prototype.replaceAll = function ( search, replacement ) {
            let target = this;
            return target.split( search ).join( replacement );
        };

        String.prototype.replaceArray = function ( find, replace ) {
            let replaceString = this;
            for ( let i = 0; i < find.length; i++ ) {
                replaceString = replaceString.replaceAll( find[ i ], replace[ i ] );
            }
            return replaceString;
        };

        let boost_find = [
            '[name]',
            '[time]',
            '[town]',
            '[state]',
            '[country]',
            '[product_name]',
            '[product_with_link]',
            '[stock]'
        ];

        let boost_replace = [
            'Name',
            'Time',
            'Town',
            'State',
            'Country',
            'Product name',
            'Product with link',
            'Stock'
        ];

        $( '.boost-make-boost-field input[type="text"][name$="[top_message]"]' ).on( 'change', function () {
            let boost_top_message = $( this ).val();
            boost_top_message = boost_top_message.replaceArray( boost_find, boost_replace );
            $( '.boost-make-boost-field-preview-data .boost-notification-message-top' ).html( boost_top_message );
        } );

        $( '.boost-make-boost-field input[type="text"][name$="[message]"]' ).on( 'change', function () {
            let boost_message = $( this ).val();
            boost_message = boost_message.replaceArray( boost_find, boost_replace );
            $( '.boost-make-boost-field-preview-data .boost-notification-message-bottom' ).html( boost_message );
        } );

        $( '.boost-make-boost-field select[name$="[notification_template]"]' ).on( 'change', function () {
            let boost_notification_template = $( this ).val();
            $( '.boost-notification' ).removeClass( 'boost-notification-square boost-notification-round' ).addClass( 'boost-notification-' + boost_notification_template );
        } );

        $( '.boost-page form' ).on( 'submit', function () {
            $( '.boost-loading' ).show();
        } );

        function resizeInput() {
            $( this ).attr( 'size', $( this ).val().length );
        }

        $( 'input.boost-resizable-input' ).each( resizeInput );

        //event for integrated form field
        $( 'select[id="boost\[integrated_form\]"]' ).on( 'change', function () {

            let selected_form = $( this ).find( ':selected' ).data( 'form' );
            let form_selector_select = $( 'select[id="boost\[form_id\]"]' );
            let username_field_select = $( 'select[id="boost\[form_username_field\]"]' );
            let surname_field_select = $( 'select[id="boost\[form_surname_field\]"]' );
            let forms_selector = [];
            let boost_form_selector = $( '#boost_form_selector' );

            $( form_selector_select ).empty();
            $( username_field_select ).empty();
            $( surname_field_select ).empty();

            $( '#integrated_form_fields option[data-form="' + selected_form + '"]' ).each( function () {
                let option = $( this );

                if ( $( this ).data( 'form' ) == selected_form ) {
                    forms_selector[ option.data( 'form-id' ) ] = {
                        title: option.data( 'form-title' ) + ' ( ' + option.data( 'form-selector' ) + ' )',
                        selector: option.data( 'form-selector' ),
                    }
                }
            } );

            forms_selector.forEach( function callback( value, index ) {
                $( form_selector_select ).append( $( '<option>', {
                    value: index,
                    text: value.title,
                    'data-form': selected_form,
                    'data-form-id': index,
                    'data-form-selector': value.selector
                } ) );
            } );

            let selected_form_id = $( form_selector_select ).find( ':selected' );

            boost_form_selector.val( selected_form_id.data( 'form-selector' ) );
            $( '#integrated_form_fields option[data-form="' + selected_form + '"][data-form-id=' + selected_form_id.data( 'form-id' ) + ']' ).each( function () {
                let option = $( this );
                $( username_field_select ).append( option.clone() );
                $( surname_field_select ).append( option.clone() );
            } );
        } );

        //event for form_id field
        $( 'select[id="boost\[form_id\]"]' ).on( 'change', function () {

            let form_selector_select = $( 'select[id="boost\[form_id\]"]' ).find( ':selected' );
            let username_field_select = $( 'select[id="boost\[form_username_field\]"]' );
            let surname_field_select = $( 'select[id="boost\[form_surname_field\]"]' );
            let boost_form_selector = $( '#boost_form_selector' );

            $( username_field_select ).empty();
            $( surname_field_select ).empty();

            boost_form_selector.val( form_selector_select.data( 'form-selector' ) );

            $( '#integrated_form_fields option[data-form="' + form_selector_select.data( 'form' ) + '"][data-form-id=' + form_selector_select.data( 'form-id' ) + ']' ).each( function () {
                let option = $( this );
                $( username_field_select ).append( option.clone() );
                $( surname_field_select ).append( option.clone() );
            } );
        } );

        $( 'select[id="boost\[form_selector\]"]' ).on( 'change', function () {

            let selected_form = $( this ).val();
            let username_field_select = $( 'select[id="boost\[form_username_field\]"]' );
            let surname_field_select = $( 'select[id="boost\[form_surname_field\]"]' );

            $( username_field_select ).empty();
            $( surname_field_select ).empty();

            $( '#capture_form_fields option[data-form-id="' + selected_form + '"]' ).each( function () {
                let option = $( this );
                $( username_field_select ).append( option.clone() );
                $( surname_field_select ).append( option.clone() );
            } );

            select_default_capture_form_fields();
        } );

        function select_default_capture_form_fields() {
            let name_templates = [ 'name', 'firstname', 'first_name', 'first-name', 'username', 'user_name', 'user-name', 'your-name' ];
            let surname_templates = [ 'surname', 'lastname', 'last_name', 'last-name', 'secondname', 'second_name', 'second-name', 'familyname', 'family_name', 'family-name' ];

            let username_field_select = $( 'select[id="boost\[form_username_field\]"]' );
            let surname_field_select = $( 'select[id="boost\[form_surname_field\]"]' );

            let comparisons = [ '=', '^=', '*=' ];
            for ( let i = 0; i < comparisons.length; i++ ) {
                if ( select_default_capture_form_field( username_field_select, name_templates, comparisons[ i ] ) ) {
                    break;
                }
            }
            for ( i = 0; i < comparisons.length; i++ ) {
                if ( select_default_capture_form_field( surname_field_select, surname_templates, comparisons[ i ] ) ) {
                    break;
                }
            }
        }

        function select_default_capture_form_field( select, field_name_templates, compare ) {
            let selected = false;
            for ( let i = 0; i < field_name_templates.length; i++ ) {
                if ( select.find( 'option[value' + compare + '"' + field_name_templates[ i ] + '"]' ).length > 0 ) {
                    select.find( 'option[value' + compare + '"' + field_name_templates[ i ] + '"]' ).attr( 'selected', 'selected' );
                    selected = true;
                    break;
                }
            }

            return selected;
        }

        $( 'input[id="boost\[capture_url\]"]' ).on( 'change paste input', function () {

            let form_selector = $( 'select[id="boost\[form_selector\]"]' );
            let capture_form_fields_select = $( 'select[id="capture_form_fields"]' );
            let username_field_select = $( 'select[id="boost\[form_username_field\]"]' );
            let surname_field_select = $( 'select[id="boost\[form_surname_field\]"]' );
            let error_container = $( 'div.boost-make-boost-capture-url div.boost-make-boost-field-error-message' );
            let input_button_box = $( this ).closest( '.boost-input-button-box' );

            input_button_box.removeClass( 'boost-search-error' );
            error_container.hide().text( '' );
            document.getElementById( form_selector.attr( 'id' ) ).selectedIndex = -1;
            document.getElementById( username_field_select.attr( 'id' ) ).selectedIndex = -1;
            document.getElementById( surname_field_select.attr( 'id' ) ).selectedIndex = -1;
            $( form_selector ).empty().closest( '.boost-make-boost-field' ).hide();
            $( username_field_select ).empty().closest( '.boost-make-boost-field' ).hide();
            $( surname_field_select ).empty().closest( '.boost-make-boost-field' ).hide();
            $( capture_form_fields_select ).empty();
        } );

        let countries_for_fakes_select = $( 'select.boost-countries-for-fakes[id="boost\[countries_for_fakes\]"]' ).select2( {
            multiple: true,
            cache: true,
            width: select_width,
            templateResult: function ( data, container ) {
                if ( data.element ) {
                    $( container ).addClass( $( data.element ).attr( "class" ) );
                }

                return data.text;
            }
        } );

        $( ".boost-countries-for-fakes-container .select2-select-all" ).on( "click", function () {
            let options = countries_for_fakes_select[ 0 ].options;
            for ( let i = 0; i < options.length; i++ )
                options[ i ].selected = true;

            countries_for_fakes_select.trigger( "change" );
        } );

        $( ".boost-countries-for-fakes-container .select2-clear" ).on( "click", function () {
            countries_for_fakes_select.val( null ).trigger( "change" );
        } );

        /* RANGE ELEMENT */
        function init_range_elements() {
            $( '.range' ).each( function () {
                let rangeLabels = $( this ).find( 'ul.range-labels li' );
                let rangeLabelWidth = 100 / rangeLabels.length;
                $( this ).find( '.range-labels' ).css( 'margin', '0 ' + 2 * rangeLabelWidth + '% 0 ' + rangeLabelWidth / 2 + '%' );
                $( rangeLabels ).css( 'width', rangeLabelWidth + '%' );
            } );
        }

        init_range_elements();

        let setActiveRange = function ( el ) {
            let curVal = parseInt( el.value );
            let rangeContainer = $( el ).closest( '.range' );

            $( rangeContainer ).find( '.range-labels li' ).removeClass( 'active' );
            $( rangeContainer ).find( 'ul.range-labels li:nth-child(' + curVal + ')' ).addClass( 'active' );
        }

        $( '.range input' ).on( 'input', function () {
            setActiveRange( this );
        } );

        $( '.range-labels li' ).on( 'click', function () {
            let index = $( this ).index();

            $( this ).closest( '.range' ).find( 'input[type="range"]' ).val( index + 1 ).trigger( 'input' );

        } );
        /* END RANGE ELEMENT */

        /* CUSTOM SELECT2 STYLE */
        $( '.select2-simple' ).select2( {
            minimumResultsForSearch: -1,
            theme: 'boost_standard_new',
            templateResult: function ( data, container ) {
                if ( data.element ) {
                    $( container ).addClass( $( data.element ).attr( "class" ) );
                }

                return data.text;
            }
        } );

        /* Select2 small select theme */
        $( '.select2-simple-small' ).select2( {
            minimumResultsForSearch: -1,
            theme: 'boost_standard_small',
        } );

        function init_select2_show_urls_block() {
            $( '.select2-standard-simple' ).select2( {
                minimumResultsForSearch: -1,
                theme: 'boost_standard_simple',
                data: [
                    {
                        id: 'contains',
                        text: 'Contains'
                    },
                    {
                        id: 'equals',
                        text: 'Equals'
                    }
                ]
            } );
        }

        init_select2_show_urls_block();

        function formatState( state ) {
            if ( !state.id ) {
                return state.text;
            }
            let $state = $(
                '<div class="select_option_data">' +
                '<div class="select_option_icon"></div><div class="select_option_label">' + state.text + '</div>' +
                '</div>'
            );
            return $state;
        }

        $( '.select2-multiple' ).select2( {
            minimumResultsForSearch: 1,
            theme: 'boost_multiple',
            closeOnSelect: false,
            width: select_width,
            templateResult: formatState,
            tags: true
        } );

        $( '.select2-standard' ).select2( {
            minimumResultsForSearch: -1,
            theme: 'boost_standard_new',
            width: select_width,
        } );

        /* DISPLAY CHECKBOXES */
        $( '.boost-display-checkbox .boost-checkbox' ).on( 'change', function () {
            let description = '';
            if ( $( this ).is( ':checked' ) ) {
                description = $( this ).attr( 'data-checked-label' );
                $( this ).closest( '.boost-make-boost-position-field' ).addClass( 'position-active' );
                $( this ).closest( '.boost-make-boost-position-field' ).find( '.boost-make-boost-field-description' ).text( description );
                $( this ).closest( '.boost-make-boost-position-field' ).find( '.position-place ' ).removeClass( 'disabled' );
            } else {
                description = $( this ).attr( 'data-unchecked-label' );
                $( this ).closest( '.boost-make-boost-position-field' ).removeClass( 'position-active' );
                $( this ).closest( '.boost-make-boost-position-field' ).find( '.boost-make-boost-field-description' ).text( description );
                $( this ).closest( '.boost-make-boost-position-field' ).find( '.position-place ' ).addClass( 'disabled' );
            }
        } );
        /* END DISPLAY CHECKBOXES */

        /* SHOW/HIDE SWITCHER */
        $( '.boost-show-hide-switcher' ).on( 'change', function () {
            let relative_box_id = $( this ).attr( 'data-relative-box-id' );

            if ( relative_box_id.length > 0 ) {
                if ( $( this ).is( ':checked' ) ) {
                    $( '#' + relative_box_id ).show( 'fast' );
                } else {
                    $( '#' + relative_box_id ).hide( 'fast' );
                }
            }
        } );
        /* END SHOW/HIDE SWITCHER */

        /* DRAG & DROP BLOCKS */
        $( 'input[name="boost[message]"]' ).on( 'change', function () {
            let message_length = $( this ).val().length;
            $( '.boost-make-boost-message-length' ).text( message_length );
        } );

        $( '.boost-message-editor' ).on( 'change keyup mouseup DOMSubtreeModified', function () {
            let message = $( this ).text();
            let max_len = parseInt( $( this ).attr( 'data-max-len' ) );
            if ( max_len > 0 && message.length > max_len ) {
                message = message.substr( 0, max_len );
                $( this ).html( $( this ).data( 'html' ) );
                $( this ).closest( '.boost-message-editor-data' ).find( 'input[type="text"]' ).trigger( 'change' );
            }
            $( this ).closest( '.boost-message-editor-data' ).find( 'input[type="text"]' ).val( message ).trigger( 'change' );
            $( this ).data( 'html', $( this ).html() );
        } );

        $( document ).on( 'focusin', '.boost-message-editor', function () {
            $( this ).data( 'html', $( this ).html() );
        } );

        $( ".draggable" ).draggable( {
            grid: [ 20, 20 ],
            containment: "window",
            cursor: 'move',
            revertDuration: 100,
            revert: 'invalid',
            helper: 'clone'
        } );

        $( ".boost-message-editor" ).droppable( {
            accept: ".draggable",
            drop: function ( event, ui ) {
                let tag_text = ui.draggable.text().trim();
                tag_text = tag_text.replaceAll( ' ', '<span class="boost-message-tag-hidden-char">_</span>' );
                let tag = ' ' + '<span contenteditable="false" class="boost-message-tag">' +
                    '<span class="boost-message-tag-hidden-char">[</span>' + tag_text.toLowerCase() +
                    '<span class="boost-message-tag-hidden-char">]</span>' +
                    '<span class="boost-message-tag-delete"></span>' +
                    '</span>' + '';

                let html = $( this ).html().trim();
                let html_new = html + tag;
                let max_len = parseInt( $( this ).attr( 'data-max-len' ) );
                if ( max_len > 0 && ( ( $( this ).text().trim() ).length + ui.draggable.text().trim().length ) > max_len ) {
                    return false;
                }
                $( this ).html( html_new );
            }
        } );

        $( 'div.boost-message-editor' ).on( 'click', '.boost-message-tag .boost-message-tag-delete', function () {
            $( this ).closest( '.boost-message-tag' ).remove();
        } );
        /* END DRAG & DROP BLOCKS */

        $( '.boost-make-boost-show-add-url' ).on( 'click', function () {
            let html = '<div class="boost-make-boost-show-url boost-make-boost-url">' +
                '<select name="boost[dc_urls][url_type][]" class="select2-standard-simple boost-input-style"></select>' +
                '<input name="boost[dc_urls][url][]" type="text" class="boost-input-style" placeholder="Type here…">' +
                '<span class="boost-url-delete"></span>' +
                '</div>';
            $( this ).closest( '.boost-make-show-urls-block-urls' ).find( '.boost-make-boost-show-urls' ).append( html );
            init_select2_show_urls_block();
        } );

        $( '.boost-make-boost-hide-add-url' ).on( 'click', function () {
            let html = '<div class="boost-make-boost-hide-url boost-make-boost-url">' +
                '<select name="boost[de_urls][url_type][]" class="select2-standard-simple boost-input-style"></select>' +
                '<input name="boost[de_urls][url][]" type="text" class="boost-input-style" placeholder="Type here…">' +
                '<span class="boost-url-delete"></span>' +
                '</div>';
            $( this ).closest( '.boost-make-hide-urls-block-urls' ).find( '.boost-make-boost-hide-urls' ).append( html );
            init_select2_show_urls_block();
        } );

        $( 'div.boost-make-boost-urls' ).on( 'click', '.boost-url-delete', function () {
            if ( $( this ).closest( '.boost-make-boost-urls' ).find( '.boost-make-boost-url' ).length > 1 ) {
                $( this ).closest( '.boost-make-boost-url' ).remove();
            }
        } );

        $( '.boost-table .boost-select-all input[type="checkbox"]' ).on( 'change', function () {
            let status = this.checked;
            $( this ).closest( 'table' ).find( '.boost-select-data input[type="checkbox"]' ).each( function () {
                $( this ).attr( 'checked', status ).change();
                $( this ).prop( 'checked', status ).change();
            } );
        } );

        $( '.boost-table tbody .boost-select-data input[type="checkbox"]' ).on( 'change', function () {
            if ( !this.checked ) {
                $( this ).closest( 'table' ).find( 'input[type="checkbox"][name="select_all"]' ).attr( 'checked', false );
                $( this ).closest( 'tr' ).removeClass( 'boost-bold' );
            } else {
                $( this ).closest( 'tr' ).addClass( 'boost-bold' );
            }

            if ( $( this ).closest( '.boost-page' ).find( '.boost-select-data input[type="checkbox"]:checked' ).length > 0 ) {
                $( '.boost-batch-actions' ).removeClass( 'boost-hidden' );
            } else {
                $( '.boost-batch-actions' ).addClass( 'boost-hidden' );
            }
        } );

        $( 'button[data-need-confirm="true"]' ).on( 'click', function ( e ) {
            e.preventDefault();
            let button = $( this ).clone().removeAttr( 'data-need-confirm' ).text( 'Yes' ).attr( 'class', 'boost-button boost-button-primary' );
            let html = '<div class="boost-confirm-window">' +
                '<div class="boost-confirm-window-data">' +
                '<div class="boost-confirm-window-message">Are you sure?</div>' +
                '<div class="boost-confirm-window-buttons">' +
                '<div class="boost-confirmation-buttons-block">' +
                $( button ).prop( 'outerHTML' ) +
                '<button class="boost-button boost-button-cancel boost-confirm-window-button-cancel">' +
                '<span>No</span>' +
                '</button>' +
                '</div>' +
                '</div>' +
                '</div>' +
                '</div>';
            $( this ).closest( 'form' ).append( html );
        } );

        $( '.boost-page' ).on( 'click', '.boost-confirm-window-button-cancel', function () {
            $( this ).closest( '.boost-confirm-window' ).remove();
        } );

        $( 'input[type="checkbox"][name*="notification_style_"]' ).on( 'change', function () {
            if ( !$( this ).is( ':checked' ) && !$( this ).closest( '.boost-make-boost-notification-style-templates' ).find( 'input[type="checkbox"][name*="notification_style_"]:checked' ).length ) {
                $( this ).prop( 'checked', true );
            }
        } );

        $( '.boost-make-boost-select-notification-image-type-container input[type="checkbox"][name*="boost["]' ).on( 'change', function () {
            if ( !$( this ).is( ':checked' ) && !$( '.boost-make-boost-select-notification-image-type-container input[type="checkbox"][name*="boost["]:checked' ).length ) {
                $( this ).prop( 'checked', true );
            }
        } );

        let banned_words = $( '.banned-words-pagination' );

        if ( banned_words.length > 0 ) {
            $( window ).on( 'keypress', function ( keypress ) {
                if ( ( keypress.keyCode == 13 ) ) {
                    banned_words.on( 'submit', function ( event ) {
                        event.preventDefault();

                        let input = keypress.target.value,
                            page = event.target.dataset.page,
                            pagination_key = event.target.dataset.paginationKey,
                            pagination_value = event.target.dataset.paginationValue,
                            total = banned_words.find( '.total-pages' ).html();

                        let page_number = input.replace( /[^0-9]/gi, '' );
                        page_number = parseInt( page_number, 10 );
                        total = parseInt( total.replace( /[^0-9]/gi, '' ), 10 );

                        if ( Number.isInteger( total ) && Number.isInteger( page_number ) ) {
                            location.href = page + '&' + pagination_key + '=' + pagination_value + '&pn=' + ( page_number > total ? total : page_number );
                        } else {
                            $( window ).off( 'keypress' );
                        }
                    } )
                }
            } )
        }

        /**
         *
         *
         * --------------- ADMIN Ajax scripts --------------
         *
         *
         **/

        function firstToUpperCase( str ) {
            return str.substr( 0, 1 ).toUpperCase() + str.substr( 1 );
        }

        function formatState( state ) {
            if ( !state.id ) {
                return state.text;
            }
            let $state = $(
                '<div class="select_option_data">' +
                '<div class="select_option_icon"></div><div class="select_option_label" title="' + state.text + '">' + state.text + '</div>' +
                '</div>'
            );
            return $state;
        }

        $( 'select.boost-search-wc-products' ).select2( {
            minimumInputLength: 3,
            multiple: true,
            theme: 'boost_multiple',
            closeOnSelect: false,
            width: select_width,
            templateResult: formatState,
            ajax: {
                url: BOOST_admin.ajaxurl,
                type: 'POST',
                dataType: 'json',
                delay: 250,
                quietMillis: 250,
                data: function ( params ) { // page is the one-based page number tracked by Select2
                    return {
                        // wp ajax action
                        action: 'boost_search_items_ajax',
                        search_string: params.term, //search term,
                        search_type: 'wc_products',
                        nonce: BOOST_admin.search_items_nonce
                    };
                },

                processResults: function ( data ) {
                    return {
                        results: $.map( data.data.items, function ( obj ) {
                            return { id: obj.id.toString(), text: obj.post_title.toString() };
                        } )
                    };
                }
            },
            cache: true
        } );

        $( 'select.boost-search-wc-product-categories' ).select2( {
            minimumInputLength: 3,
            multiple: true,
            theme: 'boost_multiple',
            closeOnSelect: false,
            width: select_width,
            templateResult: formatState,
            ajax: {
                url: BOOST_admin.ajaxurl,
                type: 'POST',
                dataType: 'json',
                delay: 250,
                quietMillis: 250,
                data: function ( params ) {// page is the one-based page number tracked by Select2
                    return {
                        // wp ajax action
                        action: 'boost_search_items_ajax',
                        search_string: params.term, //search term,
                        search_type: 'wc_product_categories',
                        nonce: BOOST_admin.search_items_nonce
                    };
                },

                processResults: function ( data ) {
                    return {
                        results: $.map( data.data.items, function ( obj ) {
                            return { id: obj.term_id.toString(), text: obj.name.toString() };
                        } )
                    };
                }
            },
            cache: true
        } );

        $( 'select.boost-search-edd-downloads' ).select2( {
            minimumInputLength: 3,
            multiple: true,
            theme: 'boost_multiple',
            closeOnSelect: false,
            width: select_width,
            templateResult: formatState,
            ajax: {
                url: BOOST_admin.ajaxurl,
                type: 'POST',
                dataType: 'json',
                delay: 250,
                quietMillis: 250,
                data: function ( params ) { // page is the one-based page number tracked by Select2
                    return {
                        // wp ajax action
                        action: 'boost_search_items_ajax',
                        search_string: params.term, //search term,
                        search_type: 'edd_downloads',
                        nonce: BOOST_admin.search_items_nonce
                    };
                },

                processResults: function ( data ) {
                    return {
                        results: $.map( data.data.items, function ( obj ) {
                            return { id: obj.id.toString(), text: obj.post_title.toString() };
                        } )
                    };
                }
            },
            cache: true
        } );

        $( 'select.boost-search-edd-download-categories' ).select2( {
            minimumInputLength: 3,
            multiple: true,
            theme: 'boost_multiple',
            closeOnSelect: false,
            width: select_width,
            templateResult: formatState,
            ajax: {
                url: BOOST_admin.ajaxurl,
                type: 'POST',
                dataType: 'json',
                delay: 250,
                quietMillis: 250,
                data: function ( params ) { // page is the one-based page number tracked by Select2
                    return {
                        // wp ajax action
                        action: 'boost_search_items_ajax',
                        search_string: params.term, //search term,
                        search_type: 'edd_download_categories',
                        nonce: BOOST_admin.search_items_nonce
                    };
                },

                processResults: function ( data ) {
                    return {
                        results: $.map( data.data.items, function ( obj ) {
                            return { id: obj.term_id.toString(), text: obj.name.toString() };
                        } )
                    };
                }
            },
            cache: true
        } );
        $( 'select.boost-search-post-types' ).select2( {
            minimumInputLength: 3,
            multiple: true,
            theme: 'boost_multiple',
            closeOnSelect: false,
            width: select_width,
            templateResult: formatState,
            ajax: {
                url: BOOST_admin.ajaxurl,
                type: 'POST',
                dataType: 'json',
                delay: 250,
                quietMillis: 250,
                data: function ( params ) { // page is the one-based page number tracked by Select2
                    return {
                        // wp ajax action
                        action: 'boost_search_items_ajax',
                        search_string: params.term, //search term,
                        search_type: 'post_types',
                        nonce: BOOST_admin.search_items_nonce
                    };
                },

                processResults: function ( data ) {
                    return {
                        results: $.map( data.data.items, function ( obj ) {
                            return { id: obj.id.toString(), text: obj.name.toString() };
                        } )
                    };
                }
            },
            cache: true
        } );

        $( 'select.boost-search-specific-pages' ).select2( {
            minimumInputLength: 3,
            multiple: true,
            theme: 'boost_multiple',
            closeOnSelect: false,
            width: select_width,
            templateResult: formatState,
            ajax: {
                url: BOOST_admin.ajaxurl,
                type: 'POST',
                dataType: 'json',
                delay: 250,
                quietMillis: 250,
                data: function ( params ) { // page is the one-based page number tracked by Select2
                    return {
                        // wp ajax action
                        action: 'boost_search_items_ajax',
                        search_string: params.term, //search term,
                        search_type: 'specific_pages',
                        nonce: BOOST_admin.search_items_nonce
                    };
                },

                processResults: function ( data ) {
                    return {
                        results: $.map( data.data.items, function ( obj ) {
                            return {
                                id: obj.id.toString(),
                                text: obj.post_title.toString() + ' (' + firstToUpperCase( obj.post_type.toString().replace( '_', ' ' ) ) + ')'
                            };
                        } )
                    };
                }
            },
            cache: true
        } );

        $( 'select.boost-search-taxonomies' ).select2( {
            minimumInputLength: 3,
            multiple: true,
            theme: 'boost_multiple',
            closeOnSelect: false,
            width: select_width,
            templateResult: formatState,
            ajax: {
                url: BOOST_admin.ajaxurl,
                type: 'POST',
                dataType: 'json',
                delay: 250,
                quietMillis: 250,
                data: function ( params ) { // page is the one-based page number tracked by Select2
                    return {
                        // wp ajax action
                        action: 'boost_search_items_ajax',
                        search_string: params.term, //search term,
                        search_type: 'taxonomies',
                        nonce: BOOST_admin.search_items_nonce
                    };
                },

                processResults: function ( data ) {
                    let terms = $.map( data.data.items.terms, function ( obj ) {
                        return {
                            id: obj.term_id.toString(),
                            text: obj.name.toString() + ' (' + firstToUpperCase( obj.taxonomy.toString().replace( '_', ' ' ) ) + ')'
                        };
                    } );
                    let taxonomies = $.map( data.data.items.taxonomies, function ( obj ) {
                        return {
                            id: obj.name.toString(), text: obj.label.toString() + ' (All)'
                        };
                    } );
                    return { results: terms.concat( taxonomies ) };
                }
            },
            cache: true
        } );

        $( '.boost-items-list-table tbody tr th .boost-items-list-table-actions button[name="edit"]' ).on( 'click', function ( event ) {
            let html = '<span>\
                                <button type="button"\
                                    name="save"\
                                    value="save"\
                                    class="boost-button boost-button-small boost-button-action action-save">\
                                    <span class="boost-action-icon"></span>\
                                    <span>Save</span>\
                                </button>\
                                <button type="button"\
                                    name="cancel"\
                                    value="cancel"\
                                    class="boost-button boost-button-small boost-button-action action-cancel">\
                                    <span class="boost-action-icon"></span>\
                                    <span>Cancel</span>\
                                </button>\
                            </span>';

            let table_row = $( this ).closest( 'tr' );
            let table_row_copy = table_row.clone();
            table_row_copy.removeClass( 'boost-items-list-row' );
            table_row_copy.addClass( 'boost-items-list-hidden-row' );
            table_row_copy.find( '.boost-items-list-table-actions' ).html( html );
            table_row_copy.find( '.boost-items-list-changeable-cell' ).each( function () {
                let cell_id = $( this ).attr( 'id' );
                let cell_text = $( this ).text();
                let new_cell_html = '<input type="text" name="' + cell_id + '" value="' + escapeHtml( cell_text ) + '" class="boost-items-list-pages-input-style"/>'
                $( this ).html( new_cell_html );
            } );

            table_row.after( table_row_copy );
            table_row.hide();
            table_row.next().show();
        } );

        $( '.boost-items-list-table tbody' ).on( 'click', 'tr th .boost-items-list-table-actions button[name="save"]', function ( event ) {
            let table_row = $( this ).closest( 'tr' );
            let action_type = table_row.closest( 'table' ).attr( 'id' );
            let item_id = table_row.attr( 'id' );
            let item_data = {};
            table_row.find( '.boost-items-list-changeable-cell' ).each( function () {
                let cell_id = $( this ).attr( 'id' );
                item_data[ cell_id ] = $( this ).find( 'input[name="' + cell_id + '"]' ).val();
            } );

            $( '.boost-loading' ).show();
            $.post(
                BOOST_admin.ajaxurl,
                {
                    // wp ajax action
                    action: 'boost_edit_item_ajax',
                    // lets
                    action_type: action_type,
                    item_id: item_id,
                    item_data: item_data,

                    // send the nonce along with the request
                    nonce: BOOST_admin.edit_item_nonce
                },
                function ( response ) {
                    if ( 'Error' != response && response.success == true ) {
                        let data = response.data;
                        let item_id = data.item_id;
                        let item_data = data.item_data;
                        let table_row = $( '.boost-items-list-table tbody tr.boost-items-list-row#' + item_id + ' th .boost-items-list-table-actions' ).closest( 'tr' );

                        table_row.find( '.boost-items-list-changeable-cell' ).each( function () {
                            let cell_id = $( this ).attr( 'id' );
                            $( this ).text( item_data[ cell_id ] );
                        } );

                        table_row.show();
                        table_row.next().hide( 0, function () {
                            $( this ).remove();
                        } );
                    }

                    $( '.boost-loading' ).hide();
                }
            );
        } );

        $( '.boost-make-boost button[name="search_forms"]' ).on( 'click', function ( event ) {
            let capture_url = $( 'input[name="boost\[capture_url\]"]' ).val();
            let input_button_box = $( this ).closest( '.boost-input-button-box' );
            let form_selector = $( 'select[id="boost\[form_selector\]"]' );
            let capture_form_fields_select = $( 'select[id="capture_form_fields"]' );
            let username_field_select = $( 'select[id="boost\[form_username_field\]"]' );
            let surname_field_select = $( 'select[id="boost\[form_surname_field\]"]' );
            let error_container = $( 'div.boost-make-boost-capture-url div.boost-make-boost-field-error-message' );

            input_button_box.removeClass( 'boost-search-error' );
            error_container.hide().text( '' );
            document.getElementById( form_selector.attr( 'id' ) ).selectedIndex = -1;
            document.getElementById( username_field_select.attr( 'id' ) ).selectedIndex = -1;
            document.getElementById( surname_field_select.attr( 'id' ) ).selectedIndex = -1;

            $( form_selector ).empty().closest( '.boost-make-boost-field' ).hide();
            $( username_field_select ).empty().closest( '.boost-make-boost-field' ).hide();
            $( surname_field_select ).empty().closest( '.boost-make-boost-field' ).hide();
            $( capture_form_fields_select ).empty();

            if ( capture_url != '' ) {
                $( '.boost-loading' ).show();
                $.post(
                    BOOST_admin.ajaxurl,
                    {
                        // wp ajax action
                        action: 'boost_search_forms_ajax',
                        // lets
                        capture_url: encodeURIComponent( capture_url ),
                        // send the nonce along with the request
                        nonce: BOOST_admin.search_forms_nonce
                    },
                    function ( response ) {
                        if ( 'Error' != response && response.success == true ) {
                            let data = response.data;
                            let forms_data = data.forms_data;

                            if ( 'error' in data ) {
                                input_button_box.addClass( 'boost-search-error' );
                                error_container.text( data[ 'error' ] ).show();
                            } else {

                                if ( forms_data.length > 0 ) {
                                    for ( let i = 0; i < forms_data.length; i++ ) {
                                        let form_name = forms_data[ i ].id != '' ? 'form#' + forms_data[ i ].id : forms_data[ i ].selector;
                                        let form_id = forms_data[ i ].id != '' ? '#' + forms_data[ i ].id : forms_data[ i ].selector;

                                        if ( form_name != '' ) {

                                            form_selector
                                                .append( $( "<option></option>" )
                                                    .attr( "value", form_id )
                                                    .text( form_name ) );

                                            for ( let j = 0; j < forms_data[ i ].fields.length; j++ ) {

                                                capture_form_fields_select.append( $( "<option></option>" )
                                                    .attr( "value", forms_data[ i ].fields[ j ].value )
                                                    .attr( "data-form-id", form_id )
                                                    .text( forms_data[ i ].fields[ j ].name ) );

                                            }
                                        }
                                    }

                                    form_selector.trigger( 'change' );
                                    $( form_selector ).closest( '.boost-make-boost-field' ).show();
                                    $( username_field_select ).closest( '.boost-make-boost-field' ).show();
                                    $( surname_field_select ).closest( '.boost-make-boost-field' ).show();
                                }
                            }
                        }

                        $( '.boost-loading' ).hide();
                    }
                );
            }

        } );

        $( '.boost-items-list-table tbody' ).on( 'click', 'tr th .boost-items-list-table-actions button[name="cancel"]', function () {

            let table_row = $( this ).closest( 'tr' ).prev();
            table_row.next().hide( 0, function () {
                $( this ).remove();
            } );
            table_row.show();
        } );

        $( 'tbody' ).on( 'keydown', '.boost-items-list-hidden-row input', ( function ( event ) {
                if ( event.keyCode == 13 ) {
                    event.preventDefault();
                    $( this ).closest( 'tr' ).find( 'button[name="save"]' ).click();
                    return false;
                }
            } )
        );
    } );

    function escapeHtml( text ) {
        let map = {
            '&': '&amp;',
            '<': '&lt;',
            '>': '&gt;',
            '"': '&quot;',
            "'": '&#039;'
        };

        return text.replace( /[&<>"']/g, function ( m ) {
            return map[ m ];
        } );
    }
} )( jQuery );
