( function ( $ ) {
    $( document ).ready( function () {
        if ( Object.keys( BOOST_public.cookie ).length > 0 ) {
            const host_name = window.location.hostname;
            let date = new Date();
            date.setTime( date.getTime() + 180 * 24 * 60 * 60 * 1000 );
            const expires = "; expires=" + date.toGMTString();
            for ( let i in BOOST_public.cookie ) {
                document.cookie = i + "=" + BOOST_public.cookie[ i ] + expires + "; path=/; domain=" + host_name + ";";
            }
        }

        let current_url = location.protocol + '//' + location.host + location.pathname;
        let leads_triggers = BOOST_public.leads_triggers;

        for ( let i in leads_triggers ) {
            if ( ( leads_triggers[ i ][ 'capture_url' ] != '' && current_url.indexOf( leads_triggers[ i ][ 'capture_url' ] ) == 0 ) || typeof leads_triggers[ i ][ 'integrated_form' ] !== 'undefined' ) {
                let selector = leads_triggers[ i ][ 'form_selector' ] != '' ? leads_triggers[ i ][ 'form_selector' ] : '#content form';
                let form = ( typeof leads_triggers[ i ][ 'integrated_form' ] !== 'undefined' ) ? leads_triggers[ i ][ 'integrated_form' ] : '';
                let action = 'submit';

                if ( form == 'FormContactForm7' ) {
                    action = 'wpcf7mailsent';
                } else if ( form == 'FormFluentForm' ) {
                    action = 'fluentform_submission_success';
                }

                if ( form != 'FormNinjaForm' ) {
                    $( selector ).on( action, {
                        boost_id: leads_triggers[ i ][ 'boost_id' ],
                        username_field: leads_triggers[ i ][ 'form_username_field' ],
                        surname_field: leads_triggers[ i ][ 'form_surname_field' ]
                    }, function ( event ) {

                        let name = event.data.username_field != '' ? $( this ).find( 'input[name="' + event.data.username_field + '"]' ).val() : '';
                        let surname = event.data.surname_field != '' ? $( this ).find( 'input[name="' + event.data.surname_field + '"]' ).val() : '';
                        let user_name = '';
                        if ( name == '' ) {
                            user_name = surname;
                        } else {
                            user_name = name + ( surname && surname != '' ? ' ' + surname[ 0 ] + '.' : '' );
                        }

                        $.post(
                            BOOST_public.ajaxurl,
                            {
                                // wp ajax action
                                action: 'boost_submit_form_ajax',

                                // lets
                                boost_id: event.data.boost_id,
                                user_name: user_name,

                                // send the nonce along with the request
                                nonce: BOOST_public.submit_form_nonce
                            },
                            function ( response ) {
                                console.log( response );
                            }
                        );
                    } );
                } else {
                    $( document ).on( 'nfFormSubmitResponse', {
                        boost_id: leads_triggers[ i ][ 'boost_id' ],
                        username_field: leads_triggers[ i ][ 'form_username_field' ],
                        surname_field: leads_triggers[ i ][ 'form_surname_field' ],
                        nf_form_id: selector
                    }, function ( event, submitted_nf_form_data ) {
                        let form_selector = event.data.nf_form_id;
                        nf_form_id = form_selector.replace( /[^0-9]/g, "" );
                        if ( nf_form_id != submitted_nf_form_data.id ) {
                            return;
                        }

                        let name_id = event.data.username_field != '' ? $( form_selector ).find( '#' + event.data.username_field + '-wrap' ).data( 'field-id' ) : '';
                        let surname_id = $( form_selector ).find( '#' + event.data.surname_field + '-wrap' ).data( 'field-id' );

                        let name = '';
                        if ( Number.isInteger( name_id ) ) {
                            name = submitted_nf_form_data.response.data.fields[ name_id ].value;
                        }

                        let surname = ''
                        if ( Number.isInteger( surname_id ) ) {
                            surname = submitted_nf_form_data.response.data.fields[ surname_id ].value;
                        }

                        let user_name = '';
                        if ( name == '' ) {
                            user_name = surname;
                        } else {
                            user_name = name + ( surname && surname != '' ? ' ' + surname[ 0 ] : '' );
                        }

                        if ( user_name != '' ) {
                            $.post(
                                BOOST_public.ajaxurl,
                                {
                                    // wp ajax action
                                    action: 'boost_submit_form_ajax',

                                    // lets
                                    boost_id: event.data.boost_id,
                                    user_name: user_name,

                                    // send the nonce along with the request
                                    nonce: BOOST_public.submit_form_nonce
                                },
                                function ( response ) {
                                    console.log( response );
                                }
                            );
                        }
                    } );
                }
            }
        }


        function getCookie( name ) {
            let value = "; " + document.cookie;
            let parts = value.split( "; " + name + "=" );
            if ( parts.length == 2 ) return parts.pop().split( ";" ).shift();
        }

        function setCookie( cname, cvalue, exdays ) {
            let d = new Date();
            d.setTime( d.getTime() + ( exdays * 24 * 60 * 60 * 1000 ) );
            let expires = "expires=" + d.toUTCString();
            document.cookie = cname + "=" + cvalue + ";" + expires + ";path=/";
        }

        function removeDuplications( notifications ) {
            $( notifications ).each( function ( i, el ) {
                if ( ( $( el ).hasClass( 'type_woocommerce' ) || $( el ).hasClass( 'type_easydigitaldownloads' ) ) && $( el ).hasClass( 'subtype_transaction' ) ) {
                    let order_id = $( el ).attr( 'data-order-id' );
                    if ( typeof order_id !== typeof undefined && order_id !== false ) {
                        if ( $( notifications ).filter( '.subtype_specific_transaction[data-order-id="' + order_id + '"]' ).length > 0 ) {
                            $( el ).remove();
                        }
                    }
                }
            } );
        }

        let settings = BOOST_public.settings;
        let boost_visibility_time = parseInt( settings[ 'boost-visibility-time' ] );
        let approximate_time_between_boosts = parseInt( settings[ 'approximate-time-between-boosts' ] );
        approximate_time_between_boosts = approximate_time_between_boosts < 5 ? approximate_time_between_boosts++ : approximate_time_between_boosts;

        let page = 0;
        let full_loaded = false;
        let loading = false;
        let notifications = [];

        let close_boosts_setting = parseInt( settings[ 'close-boosts' ] );
        let closed_boosts = getCookie( 'STYXKEY_BOOSTS_CLOSED_BOOSTS' );
        if ( typeof closed_boosts === 'undefined' || !closed_boosts || close_boosts_setting === 0 ) {

            $.post(
                BOOST_public.ajaxurl,
                {
                    // wp ajax action
                    action: 'boost_notifications_part_load_ajax',

                    // lets
                    page: page,
                    current_url: current_url,

                    // send the nonce along with the request
                    nonce: BOOST_public.notifications_part_load_nonce
                },

                function ( response ) {
                    if ( 'Error' !== response && ( response.success === true || response.success === 'true' ) ) {
                        let notifications_part_html = response.data.notifications_part_html;
                        let notifications_part = $( notifications_part_html ).find( '.boost-notification' );
                        let notification_part_count = notifications_part.length;
                        if ( notification_part_count > 0 ) {
                            removeDuplications( notifications_part );
                            $( 'body' ).append( '<div id="boost-notifications-wrapper"></div>' );
                            $( '#boost-notifications-wrapper' ).append( notifications_part );
                            $.merge( notifications, notifications_part );
                            startShowingNotifications();
                        } else {
                            page--;
                            full_loaded = true;
                        }
                    }
                    loading = false;
                }
            );

            async function startShowingNotifications() {
                if ( notifications.length > 0 ) {

                    let cm_sticky = $( '#cs_preview_popup_button .fixed-preview' );
                    let cm_popup = $( '#cs_preview_popup .preview_wrap_showing' );

                    while ( cm_sticky.length > 0 || cm_popup.length > 0 ) {
                        await delay( 100 );
                        cm_sticky = $( '#cs_preview_popup_button .fixed-preview' );
                        cm_popup = $( '#cs_preview_popup .preview_wrap_showing' );
                    }
                    removeDuplications( notifications );

                    setTimeout( function () {
                        let i = 0;
                        setTimeout( function show_notification() {
                            let closed_boosts = getCookie( 'STYXKEY_BOOSTS_CLOSED_BOOSTS' );
                            if ( closed_boosts && close_boosts_setting === 1 ) {
                                return;
                            }

                            cm_sticky = $( '#cs_preview_popup_button .fixed-preview' );
                            cm_popup = $( '#cs_preview_popup .preview_wrap_showing' );

                            if ( cm_sticky.length === 0 && cm_popup.length === 0 ) {
                                // show notification
                                $( notifications[ i ] ).show( "fast" );
                                setTimeout( function () {
                                    let closed_boosts = getCookie( 'STYXKEY_BOOSTS_CLOSED_BOOSTS' );
                                    if ( closed_boosts && close_boosts_setting === 1 ) {
                                        return;
                                    }

                                    // hide notification
                                    $( notifications[ i ] ).hide( "fast", function () {
                                        $( this ).remove();
                                    } );

                                    // show the next notification
                                    i++;
                                    if ( notifications.length !== 0 && ( ( i + 1 ) / notifications.length ) >= 0.8 && !loading && !full_loaded ) {
                                        notificationsPartLoad();
                                    }

                                    if ( i < notifications.length ) {
                                        setTimeout( show_notification, ( Math.floor( Math.random() * 3 ) + approximate_time_between_boosts - 1 ) * 1000 );
                                    }

                                }, boost_visibility_time * 1000 );
                            } else {
                                setTimeout( show_notification, ( Math.floor( Math.random() * 3 ) + approximate_time_between_boosts - 1 ) * 1000 );
                            }

                        }, Math.floor( ( Math.random() * 4 ) + 2 ) * 1000 );

                    }, parseInt( settings[ 'start-boosts-after' ] * 1000 ) );
                }
            }

            function notificationsPartLoad() {
                loading = true;
                page++;
                $.post(
                    BOOST_public.ajaxurl,
                    {
                        // wp ajax action
                        action: 'boost_notifications_part_load_ajax',

                        // lets
                        page: page,
                        current_url: current_url,

                        // send the nonce along with the request
                        nonce: BOOST_public.notifications_part_load_nonce
                    },
                    function ( response ) {
                        if ( 'Error' !== response && ( response.success === true || response.success === 'true' ) ) {
                            let notifications_part_html = response.data.notifications_part_html;
                            let notifications_part = $( notifications_part_html ).find( '.boost-notification' );
                            let notification_part_count = notifications_part.length;
                            if ( notification_part_count > 0 ) {
                                removeDuplications( notifications_part );
                                $( '#boost-notifications-wrapper' ).append( notifications_part );
                                $.merge( notifications, notifications_part )
                            } else {
                                page--;
                                full_loaded = true;
                            }
                        }
                        loading = false;
                    }
                );
            }
        }

        $( document )
            .off( 'click', '.boost-notification.allow-to-close .boost-close-button' )
            .on( 'click', '.boost-notification.allow-to-close .boost-close-button', function () {

                setCookie( 'STYXKEY_BOOSTS_CLOSED_BOOSTS', true, 1 );
                notifications = [];
                $( '#boost-notifications-wrapper' ).empty();

                // hide notification
                $( this ).closest( '.boost-notification' ).hide( "fast", function () {
                    $( this ).remove();
                } );
            } );
    } );
} )( jQuery );

function delay( time ) {
    return new Promise( resolve => setTimeout( resolve, time ) );
}